import os
from ConfigParser import ConfigParser

import dbus
import dbus.lowlevel

from .debug import trace

def signal(name, args=None, signature=None, uid=500, gid=500):
    """Send the specified DBus signal on the session bus."""
    pid = os.fork()
    if not pid:
        try:
            os.setuid(uid)

            dsba_file = open('/home/olpc/.sugar/default/session.info')
            cp = ConfigParser()
            cp.readfp(dsba_file)
            bus_address = cp.get('Session', 'dbus_address').strip()
            dsba_file.close()

            bus = dbus.bus.BusConnection(address_or_type=bus_address)
            msg = dbus.lowlevel.SignalMessage('/', 'org.laptop.security.Rainbow', name)

            if signature is not None:
                msg.append(signature=signature, *args)

            bus.send_message(msg)
            bus.flush()

        except:
            trace()
            raise

        finally:
            os._exit(0)
    else:
        os.waitpid(pid, 0)

